Package net.sf.saxon.expr

## Class LetExpression

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.Assignation
    - - net.sf.saxon.expr.LetExpression

- All Implemented Interfaces:
    `Binding`, `ExportAgent`, `TailCallReturner`, `LocalBinding`, `Locatable`, `IdentityComparable`, `Traceable`
  Direct Known Subclasses:
    `EagerLetExpression`

      public class LetExpression
      extends Assignation
      implements TailCallReturner

  A LetExpression represents the XQuery construct let $x := expr return expr. It is used also for XSLT local variables.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Assignation

      `hasLoopingReference, isIndexedVariable, references, requiredType, slotNumber, variableName`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LetExpression()` | Create a LetExpression

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `int` | `computeCardinality()` | Determine the static cardinality of the expression
    `int` | `computeSpecialProperties()` | Get the static properties of this expression (other than its type).
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `boolean` | `effectiveBooleanValue​(XPathContext context)` | Get the effective boolean value of the expression.
    `Sequence` | `eval​(XPathContext context)` | Evaluate the variable.
    `Item` | `evaluateItem​(XPathContext context)` | Evaluate the expression as a singleton
    `void` | `evaluatePendingUpdates​(XPathContext context, PendingUpdateList pul)` | Evaluate an updating expression, adding the results to a Pending Update List.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `void` | `gatherProperties​(java.util.function.BiConsumer<java.lang.String,​java.lang.Object> consumer)` | Get the properties of this object to be included in trace messages, by supplying the property values to a supplied consumer function
    `double` | `getCost()` | Return the estimated cost of evaluating an expression.
    `Evaluator` | `getEvaluator()` |
    `java.lang.String` | `getExpressionName()` | Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getImplementationMethod()` | An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `IntegerValue[]` | `getIntegerBounds()` | For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
    `ItemType` | `getItemType()` | Determine the data type of the items returned by the expression, if possible
    `UType` | `getStaticUType​(UType contextItemType)` | Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
    `boolean` | `implementsStaticTypeCheck()` | Determine whether this expression implements its own method for static type checking
    `boolean` | `isInstruction()` | Ask whether this expression is an instruction.
    `boolean` | `isLiftable​(boolean forStreaming)` | Ask whether the expression can be lifted out of a loop, assuming it has no dependencies on the controlling variable/focus of the loop
    `boolean` | `isNeedsLazyEvaluation()` |
    `boolean` | `isVacuousExpression()` | Determine whether this is a vacuous expression as defined in the XQuery update specification
    `SequenceIterator` | `iterate​(XPathContext context)` | Iterate over the result of the expression to return a sequence of items
    `int` | `markTailFunctionCalls​(StructuredQName qName, int arity)` | Mark tail function calls
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `void` | `process​(Outputter output, XPathContext context)` | Process this expression as an instruction, writing results to the current outputter
    `TailCall` | `processLeavingTail​(Outputter output, XPathContext context)` | ProcessLeavingTail: called to do the real work of this instruction.
    `void` | `resetLocalStaticProperties()` | Reset the static properties of the expression to -1, so that they have to be recomputed next time they are used.
    `void` | `setEvaluationMode​(EvaluationMode mode)` |
    `void` | `setEvaluator()` |
    `void` | `setEvaluator​(Evaluator evaluator)` |
    `void` | `setInstruction​(boolean inst)` | Say whether this expression originates as an XSLT instruction
    `void` | `setNeedsEagerEvaluation​(boolean req)` | Say that this variable must be evaluated eagerly.
    `void` | `setNeedsLazyEvaluation​(boolean req)` |
    `Expression` | `staticTypeCheck​(SequenceType req, boolean backwardsCompatible, RoleDiagnostic role, ExpressionVisitor visitor)` | Static type checking for let expressions is delegated to the expression itself, and is performed on the "action" expression, to allow further delegation to the branches of a conditional
    `java.lang.String` | `toShortString()` | Produce a short string identifying the expression for use in error messages
    `java.lang.String` | `toString()` | The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Type-check the expression.

    - ### Methods inherited from class net.sf.saxon.expr.Assignation

      `addReference, addToPathMap, checkForUpdatingSubexpressions, computeDependencies, evaluateVariable, getAction, getActionOp, getIntegerBoundsForVariable, getLocalSlotNumber, getNominalReferenceCount, getObjectName, getRequiredSlots, getRequiredType, getSequence, getSequenceOp, getVariableEQName, getVariableName, getVariableQName, hasVariableBinding, isAssignable, isGlobal, isIndexedVariable, isUpdatingExpression, operands, rebuildReferenceList, refineTypeInformation, removeDeadReferences, replaceVariable, setAction, setIndexedVariable, setRequiredType, setSequence, setSlotNumber, setVariableQName, suppressValidation, unordered, verifyReferences`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, allowExtractingCommonSubexpressions, checkedOperands, computeHashCode, computeStaticProperties, dynamicError, equals, evaluateAsString, explain, getCardinality, getConfiguration, getDependencies, getEvaluationMethod, getExtraProperty, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getNetCost, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStreamerName, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, identityHashCode, isCallOn, isEqual, isIdentical, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, operandList, operandSparseList, optimizeChildren, prepareForStreaming, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, toPattern, typeCheckChildren, typeError, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LetExpression

          public LetExpression()

      Create a LetExpression

  - ### Method Detail

    - #### setInstruction

          public void setInstruction​(boolean inst)

      Say whether this expression originates as an XSLT instruction
      Parameters:
        `inst` - true if this is an xsl:variable instruction

    - #### isInstruction

          public boolean isInstruction()

      Ask whether this expression is an instruction. In XSLT streamability analysis this is used to distinguish constructs corresponding to XSLT instructions from other constructs.
      Overrides:
        `isInstruction` in class `Expression`
      Returns:
        true if this construct originates as an XSLT instruction

    - #### getExpressionName

          public java.lang.String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Expression`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### setNeedsEagerEvaluation

          public void setNeedsEagerEvaluation​(boolean req)

      Say that this variable must be evaluated eagerly. This is a requirement for example for variables appearing within a try/catch, or for variables referenced from within a construct that uses multi-threading, for example xsl:result-document or a multi-threaded xsl:for-each.
      Parameters:
        `req` - set to true if eager evaluation is required

    - #### setNeedsLazyEvaluation

          public void setNeedsLazyEvaluation​(boolean req)

    - #### isNeedsLazyEvaluation

          public boolean isNeedsLazyEvaluation()

    - #### isLiftable

          public boolean isLiftable​(boolean forStreaming)

      Ask whether the expression can be lifted out of a loop, assuming it has no dependencies on the controlling variable/focus of the loop
      Overrides:
        `isLiftable` in class `Expression`
      Parameters:
        `forStreaming` - true if we are handling streaming code (where rewrites need to be more cautious)
      Returns:
        true if the expression can be loop lifted

    - #### resetLocalStaticProperties

          public void resetLocalStaticProperties()

      Description copied from class: `Expression`
      Reset the static properties of the expression to -1, so that they have to be recomputed next time they are used.
      Overrides:
        `resetLocalStaticProperties` in class `Expression`

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Type-check the expression. This also has the side-effect of counting the number of references to the variable (treating references that occur within a loop specially)
      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### implementsStaticTypeCheck

          public boolean implementsStaticTypeCheck()

      Determine whether this expression implements its own method for static type checking
      Overrides:
        `implementsStaticTypeCheck` in class `Expression`
      Returns:
        true - this expression has a non-trivial implementation of the staticTypeCheck() method

    - #### staticTypeCheck

          public Expression staticTypeCheck​(SequenceType req,
                                            boolean backwardsCompatible,
                                            RoleDiagnostic role,
                                            ExpressionVisitor visitor)
                                     throws XPathException

      Static type checking for let expressions is delegated to the expression itself, and is performed on the "action" expression, to allow further delegation to the branches of a conditional
      Overrides:
        `staticTypeCheck` in class `Expression`
      Parameters:
        `req` - the required type
        `backwardsCompatible` - true if backwards compatibility mode applies
        `role` - the role of the expression in relation to the required type
        `visitor` - an expression visitor
      Returns:
        the expression after type checking (perhaps augmented with dynamic type checking code)
      Throws:
        `XPathException` - if failures occur, for example if the static type of one branch of the conditional is incompatible with the required type

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Perform optimisation of an expression and its subexpressions.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### setEvaluator

          public void setEvaluator()

    - #### getCost

          public double getCost()

      Return the estimated cost of evaluating an expression. This is a very crude measure based on the syntactic form of the expression (we have no knowledge of data values). We take the cost of evaluating a simple scalar comparison or arithmetic expression as 1 (one), and we assume that a sequence has length 5. The resulting estimates may be used, for example, to reorder the predicates in a filter expression so cheaper predicates are evaluated first.
      Overrides:
        `getCost` in class `Assignation`
      Returns:
        a rough estimate of the evaluation cost

    - #### isVacuousExpression

          public boolean isVacuousExpression()

      Determine whether this is a vacuous expression as defined in the XQuery update specification
      Overrides:
        `isVacuousExpression` in class `Expression`
      Returns:
        true if this expression is vacuous

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### getIntegerBounds

          public IntegerValue[] getIntegerBounds()

      For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.
      Overrides:
        `getIntegerBounds` in class `Expression`
      Returns:
        the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

    - #### getImplementationMethod

          public int getImplementationMethod()

      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided directly. The other methods will always be available indirectly, using an implementation that relies on one of the other methods.
      Specified by:
        `getImplementationMethod` in class `Expression`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### gatherProperties

          public void gatherProperties​(java.util.function.BiConsumer<java.lang.String,​java.lang.Object> consumer)

      Get the properties of this object to be included in trace messages, by supplying the property values to a supplied consumer function
      Specified by:
        `gatherProperties` in interface `Traceable`
      Parameters:
        `consumer` - the function to which the properties should be supplied, as (property name, value) pairs.

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Iterate over the result of the expression to return a sequence of items
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### eval

          public Sequence eval​(XPathContext context)
                        throws XPathException

      Evaluate the variable.
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        the result of evaluating the expression that is bound to the variable
      Throws:
        `XPathException`

    - #### evaluateItem

          public Item evaluateItem​(XPathContext context)
                            throws XPathException

      Evaluate the expression as a singleton
      Overrides:
        `evaluateItem` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue​(XPathContext context)
                                        throws XPathException

      Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.
      Overrides:
        `effectiveBooleanValue` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### process

          public void process​(Outputter output,
                              XPathContext context)
                       throws XPathException

      Process this expression as an instruction, writing results to the current outputter
      Overrides:
        `process` in class `Expression`
      Parameters:
        `output` - the destination for the result
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getItemType

          public ItemType getItemType()

      Determine the data type of the items returned by the expression, if possible
      Specified by:
        `getItemType` in class `Expression`
      Returns:
        one of the values Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

    - #### getStaticUType

          public UType getStaticUType​(UType contextItemType)

      Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
      Overrides:
        `getStaticUType` in class `Expression`
      Parameters:
        `contextItemType` - the type of the context item
      Returns:
        the static item type of the expression according to the XSLT 3.0 defined rules

    - #### computeCardinality

          public int computeCardinality()

      Determine the static cardinality of the expression
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`. May also return `StaticProperty.ALLOWS_ZERO` if the result is known to be an empty sequence, or `StaticProperty.ALLOWS_MANY` if if is known to return a sequence of length two or more.

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Overrides:
        `computeSpecialProperties` in class `Expression`
      Returns:
        the special properties, as a bit-significant integer

    - #### markTailFunctionCalls

          public int markTailFunctionCalls​(StructuredQName qName,
                                           int arity)

      Mark tail function calls
      Overrides:
        `markTailFunctionCalls` in class `Expression`
      Parameters:
        `qName` - the name of the function
        `arity` - the arity (number of parameters) of the function
      Returns:
        `UserFunctionCall.NOT_TAIL_CALL` if no tail call was found; `UserFunctionCall.FOREIGN_TAIL_CALL` if a tail call on a different function was found; `UserFunctionCall.SELF_TAIL_CALL` if a tail recursive call was found and if this call accounts for the whole of the value.

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - variables whose binding needs to change
      Returns:
        the copy of the original expression

    - #### processLeavingTail

          public TailCall processLeavingTail​(Outputter output,
                                             XPathContext context)
                                      throws XPathException

      ProcessLeavingTail: called to do the real work of this instruction. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Parameters:
        `output` - the destination for the result
        `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
      Returns:
        null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates​(XPathContext context,
                                             PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException
      Overrides:
        `evaluatePendingUpdates` in class `Expression`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails

    - #### toString

          public java.lang.String toString()

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax
      Overrides:
        `toString` in class `Expression`
      Returns:
        a representation of the expression as a string

    - #### toShortString

          public java.lang.String toShortString()

      Produce a short string identifying the expression for use in error messages
      Overrides:
        `toShortString` in class `Expression`
      Returns:
        a short string, sufficient to identify the expression

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### setEvaluator

          public void setEvaluator​(Evaluator evaluator)

    - #### setEvaluationMode

          public void setEvaluationMode​(EvaluationMode mode)

    - #### getEvaluator

          public Evaluator getEvaluator()